from __future__ import absolute_import
from __future__ import division
from __future__ import print_function
from __future__ import unicode_literals

import logging

from flask import Blueprint, request, jsonify
import requests
from rasa_core.channels.channel import UserMessage, OutputChannel
from rasa_core.channels.channel import CollectingOutputChannel
from rasa_core.channels import RestInput
import json

logger = logging.getLogger(__name__)


class CustomOutput(OutputChannel):
	"""A bot that uses a custom channel to communicate."""

	def __init__(self, url, access_token):
		self.access_token = access_token
		self.url = url

	def send_text_message(self, recipient_id, message):
		# you probably use http to send a message
		url = self.url
		if self.access_token is not None:
			headers = {"Auth-token": self.access_token}
		else:
			headers = {}
		'''	
		file = open("testfile.txt","w")
		file.write(message)
		file.write(url)
		file.close()
		print (' post data ')
		'''
		try:
			response = requests.post(url,data = {'message':message,'recipient_id':recipient_id },headers=headers,verify = False)
			print (response.content)
		except requests.exceptions.RequestException as e:
			print (e)

	def send_text_with_buttons(self, recipient_id, message, buttons):
		# you probably use http to send a message
		url = self.url
		if self.access_token is not None:
			headers = {"Auth-token": self.access_token}
		else:
			headers = {}
		'''
		file = open("testfile.txt","w")
		file.write(message)
		file.write(url)
		file.close()
		print (buttons)
		'''
		try:

			response = requests.post(url,data = {'message':message,'recipient_id':recipient_id ,'button': json.dumps(buttons)},headers=headers,verify = False)
			print (response.content)
		except requests.exceptions.RequestException as e:
			print (e)



class CustomInput(RestInput):
	"""A custom http input channel.
	This implementation is the basis for a custom implementation of a chat
	frontend. You can customize this to send messages to Rasa Core and
	retrieve responses from the agent."""

	def __init__(self, url, access_token=None):
		self.out_channel = CustomOutput(url, access_token)

	def blueprint(self, on_new_message):
		custom_webhook = Blueprint('custom_webhook', __name__)

		@custom_webhook.route("/", methods=['GET'])
		def health():
			return jsonify({"status": "everything is fine"})

		@custom_webhook.route("/webhook", methods=['POST'])
		def receive():
			payload = request.json
			#return payload.get("sender", None)
			#return jsonify({"inside receive": "everything is fine"})
			sender_id = payload.get("sender", None)
			text = payload.get("message", None)
			out = CollectingOutputChannel()
			on_new_message(UserMessage(text, self.out_channel, sender_id))
			#responses = [m for _, m in out.messages]
			#responses = [m["text"] for m in out.messages]
			#return out.messages
			#return jsonify(out.messages)
			return "success"

		return custom_webhook
